<template>
  <div class="app-container">
    <el-row :gutter="20">
      <el-col :span="4" :xs="24">
        <div class="head-container">
          <el-input v-model="areaName" placeholder="请输入地块名称" clearable size="small" prefix-icon="el-icon-search"
            style="margin-bottom: 20px" />
        </div>
        <div class="head-container">
          <el-tree :data="areaOptions" :props="defaultProps" :expand-on-click-node="false" :filter-node-method="filterNode" ref="tree"
            node-key="id" default-expand-all highlight-current @node-click="handleNodeClick" />
        </div>
      </el-col>
      <el-col :span="20" :xs="24">
        <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
          <el-form-item label="建筑名称" prop="bldgName">
            <el-input v-model="queryParams.bldgName" placeholder="请输入建筑名称" clearable @keyup.enter.native="handleQuery" />
          </el-form-item>
          <el-form-item>
            <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
            <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
          </el-form-item>
        </el-form>

        <el-row :gutter="10" class="mb8">
          <el-col :span="1.5">
            <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd" v-hasPermi="['basecfg:building:add']">新增
            </el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button type="success" plain icon="el-icon-edit" size="mini" :disabled="single" @click="handleUpdate"
              v-hasPermi="['basecfg:building:edit']">修改</el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button type="danger" plain icon="el-icon-delete" size="mini" :disabled="multiple" @click="handleDelete"
              v-hasPermi="['basecfg:building:remove']">删除</el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button type="warning" plain icon="el-icon-download" size="mini" @click="handleExport"
              v-hasPermi="['basecfg:building:export']">导出</el-button>
          </el-col>
          <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
        </el-row>

        <el-table v-loading="loading" :data="buildingList" @selection-change="handleSelectionChange">
          <el-table-column type="selection" width="55" align="center" />
          <el-table-column label="建筑名称" align="left" prop="bldgName" />
          <el-table-column label="服务区" align="center" prop="areaShortName" />
          <el-table-column label="建筑编码" align="center" prop="bldgCode" />
          <el-table-column label="位置描述" align="center" prop="address" />
          <el-table-column label="建筑层数" align="center">
            <template slot-scope="scope">
              <span>{{ scope.row.downBldgFloor + scope.row.upBldgFloor + "层" }}</span>
            </template>
          </el-table-column>
          <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
            <template slot-scope="scope">
              <el-button size="mini" type="text"  icon="el-icon-edit" @click="handleUpdate(scope.row)" v-hasPermi="['basecfg:building:edit']">
                修改</el-button>
              <el-button size="mini" type="text" icon="el-icon-delete" class="deleteBtn" @click="handleDelete(scope.row)" v-hasPermi="['basecfg:building:remove']">
                删除</el-button>

            </template>
          </el-table-column>
        </el-table>

        <pagination v-show="total>0" :total="total" :page.sync="queryParams.pageNum" :limit.sync="queryParams.pageSize"
          @pagination="getList" />

        <!-- 添加或修改建筑基本信息对话框 -->
        <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
          <el-form ref="form" :model="form" :rules="rules" label-width="120px">
            <el-form-item label="所属地块" prop="areaCode">
              <treeselect v-model="form.areaCode" :options="areaOptions" :show-count="true" placeholder="请选择归属园区" />
            </el-form-item>
            <el-form-item label="建筑编码" prop="bldgCode">
              <el-input v-model="form.bldgCode" placeholder="请输入建筑编码" :readonly="isReadOnly" />
            </el-form-item>
            <el-form-item label="建筑名称" prop="bldgName">
              <el-input v-model="form.bldgName" placeholder="请输入建筑名称" />
            </el-form-item>
            <el-form-item label="详细地址" prop="address">
              <el-input v-model="form.address" placeholder="请输入详细地址" />
            </el-form-item>
            <el-form-item label="地上层数" prop="upBldgFloor">
              <el-input v-model="form.upBldgFloor" oninput="value=value.replace(/^0(0+|\d+)|[^\d]+/g,'')" placeholder="请输入建筑层数" />
            </el-form-item>
            <el-form-item label="地下层数" prop="downBldgFloor">
              <el-input v-model="form.downBldgFloor" oninput="value=value.replace(/^0(0+|\d+)|[^\d]+/g,'')" placeholder="请输入建筑层数" />
            </el-form-item>
            <el-form-item label="建筑高度(米)" prop="bldgHeight">
              <el-input v-model="form.bldgHeight" oninput ="value=value.replace(/[^0-9.]/g,'')" placeholder="请输入建筑高度" />
            </el-form-item>
            <el-form-item label="建筑面积(平方米)" prop="floorArea">
              <el-input v-model="form.floorArea" oninput ="value=value.replace(/[^0-9.]/g,'')" placeholder="请输入建筑面积" />
            </el-form-item>
            <el-form-item label="主要用途" prop="bldgUsage">
              <el-input v-model="form.bldgUsage" placeholder="请输入主要用途" />
            </el-form-item>
          </el-form>
          <div slot="footer" class="dialog-footer">
            <el-button type="primary" @click="submitForm">确 定</el-button>
            <el-button @click="cancel">取 消</el-button>
          </div>
        </el-dialog>
      </el-col>
    </el-row>
  </div>
</template>

<script>
import { listBuilding, getBuilding, delBuilding, addBuilding, updateBuilding } from '@/api/basecfg/building'
import { areaTreeSelect } from '@/api/basecfg/area'
import Treeselect from '@riophae/vue-treeselect'
import '@riophae/vue-treeselect/dist/vue-treeselect.css'

export default {
  name: 'Building',
  components: { Treeselect },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 建筑基本信息表格数据
      buildingList: [],
      // 弹出层标题
      title: '',
      // 是否显示弹出层
      open: false,
      // 区域名称
      areaName: undefined,
      // 区域树选项
      areaOptions: undefined,
      defaultProps: {
        children: 'children',
        label: 'label'
      },
      isReadOnly: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        areaCode: null,
        bldgCode: null,
        bldgName: null,
        address: null,
        upBldgFloor: null,
        downBldgFloor: null,
        bldgHeight: null,
        floorArea: null,
        bldgUsage: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        bldgCode: [{ required: true, message: '建筑编码不能为空', trigger: 'blur' }],
        bldgName: [{ required: true, message: '建筑名称不能为空', trigger: 'blur' }]
      }
    }
  },
  watch: {
    // 根据名称筛选区域树
    areaName(val) {
      this.$refs.tree.filter(val)
    }
  },
  created() {
    this.getList()
    this.getAreaTree('Area')
  },
  methods: {
    /** 查询建筑基本信息列表 */
    getList() {
      this.loading = true
      listBuilding(this.queryParams).then(response => {
        this.buildingList = response.rows
        this.total = response.total
        this.loading = false
      })
    },
    /** 查询区域树结构 */
    getAreaTree(tier) {
      areaTreeSelect(tier).then(response => {
        this.areaOptions = response.data
      })
    },
    // 筛选节点
    filterNode(value, data) {
      if (!value) return true
      return data.label.indexOf(value) !== -1
    },
    // 节点单击事件
    handleNodeClick(data) {
      this.queryParams.areaCode = data.id
      this.handleQuery()
    },
    // 取消按钮
    cancel() {
      this.open = false
      this.reset()
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        areaCode: null,
        bldgCode: null,
        bldgName: null,
        address: null,
        upBldgFloor: null,
        downBldgFloor: null,
        bldgHeight: null,
        floorArea: null,
        bldgUsage: null
      }
      this.resetForm('form')
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1
      this.getList()
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.queryParams.areaCode = null
      this.resetForm('queryForm')
      this.handleQuery()
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset()
      this.open = true
      this.isReadOnly = false
      this.title = '添加建筑基本信息'
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset()
      this.isReadOnly = false
      const id = row.id || this.ids
      getBuilding(id).then(response => {
        this.form = response.data
        this.open = true
        this.title = '修改建筑基本信息'
      })
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs['form'].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateBuilding(this.form).then(response => {
              this.$modal.msgSuccess('修改成功')
              this.open = false
              this.getList()
            })
          } else {
            addBuilding(this.form).then(response => {
              this.$modal.msgSuccess('新增成功')
              this.open = false
              this.getList()
            })
          }
        }
      })
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids
      this.$modal
        .confirm('是否确认删除建筑基本信息编号为"' + ids + '"的数据项？')
        .then(function() {
          return delBuilding(ids)
        })
        .then(() => {
          this.getList()
          this.$modal.msgSuccess('删除成功')
        })
        .catch(() => {})
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download(
        'ems/basecfg/area/building/export',
        {
          ...this.queryParams
        },
        `building_${new Date().getTime()}.xlsx`
      )
    }
  }
}
</script>
